<template>
  <div v-show="focus" class="tooltip" ref="main"><slot></slot></div>
</template>

<script lang="ts">
import { Vue } from "vue-class-component";

export default class Tooltip extends Vue {
  public focus = false;

  public mouseenterHandler = (): void => {
    this.focus = true;
  };

  public mouseleaveHandler = (): void => {
    this.focus = false;
  };

  public mounted(): void {
    const root: HTMLElement | null = this.$refs.main as HTMLElement | null;
    const parent: HTMLElement | null | undefined = root?.parentElement;

    parent?.addEventListener("mouseenter", this.mouseenterHandler);
    parent?.addEventListener("mouseleave", this.mouseleaveHandler);
  }
  public unmounted(): void {
    const root: HTMLElement | null = this.$refs.main as HTMLElement | null;
    const parent: HTMLElement | null | undefined = root?.parentElement;

    parent?.removeEventListener("mouseenter", this.mouseenterHandler);
    parent?.removeEventListener("mouseleave", this.mouseleaveHandler);
  }
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.tooltip {
  line-height: 12px;
  position: absolute;
  top: -6px;
  right: calc(100% + 10px);
  background-color: $black_text;
  color: $white_bg;
  font-weight: normal;
  font-size: 10px;
  width: max-content;
  padding: $small_spacing $small_margin;

  &::after {
    content: "";
    width: 0px;
    height: 0px;
    position: absolute;
    border: solid 10px transparent;
    border-left: solid 10px $black_text;
    right: -16px;
    top: 6px;
  }
}
</style>
